SystemOrganization addCategory: #'PW-Parser'!

PEGActor subclass: #PWDocumentActor
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Parser'!

!PWDocumentActor methodsFor: 'as yet unclassified' stamp: 'chc 1/26/2017 10:41'!
Component: flow
	<action: 'Component' arguments: #(2) >
	| string class comp|
	string := (self collectString: flow).
	class := Smalltalk at: (string asSymbol).
	comp := class new.
	^PWDocumentComponent with: comp! !

!PWDocumentActor methodsFor: 'as yet unclassified' stamp: 'chc 9/15/2016 08:29'!
Heading1: flow
	<action: 'Heading1' arguments: #(3) >
	|heading|
	heading := self collectString: flow.
	^TWHeading with: (TWText text: heading) level: 1! !

!PWDocumentActor methodsFor: 'as yet unclassified' stamp: 'chc 9/15/2016 07:48'!
Page: flow
	<action: 'Page' >
	|page|
	page := self collectDocumentObjects: flow.
	^page! !

!PWDocumentActor methodsFor: 'as yet unclassified' stamp: 'chc 9/15/2016 08:28'!
Paragraph: flow
	<action: 'Paragraph' >
	|para|
	para := self collectString: flow.
	^TWParagraph with: (TWText text: para) ! !

!PWDocumentActor methodsFor: 'as yet unclassified' stamp: 'chc 9/15/2016 07:43'!
collectDocumentObjects: flow
	| oc |
	oc := OrderedCollection new.
	flow do: [:ea| oc add: ea].
	^oc! !

!PWDocumentActor methodsFor: 'as yet unclassified' stamp: 'chc 9/15/2016 08:27'!
collectString: flow
	| string |
	string := String new writing.
	flow do: [:ea| string write: ea].
	^string conclusion! !

PEGActor subclass: #PWStringActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Parser'!

!PWStringActor commentStamp: 'chc 3/22/2016 09:29' prior: 0!
This class renders OrderedCollections and Arrays parsed by the #grammarWiki in the PEGParser into HTML. !

!PWStringActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Bold: flow
	<action: 'Bold' arguments: #(2)>
	^'<b>' , (self collectString: flow) , '</b>'! !

!PWStringActor methodsFor: 'argument' stamp: 'chc 3/22/2016 10:19'!
Bullet1: flow
	<action: 'Bullet1' arguments: #(3)>
	^'<li>' , (self collectString: flow) , '</li>'! !

!PWStringActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading1: flow
	<action: 'Heading1' arguments: #(3) >
	^'<h1>' , (self collectString: flow) , '</h1>'! !

!PWStringActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading2: flow
	<action: 'Heading2' arguments: #(3) >
	^'<h2>' , (self collectString: flow) , '</h2>'! !

!PWStringActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading3: flow
	<action: 'Heading3' arguments: #(3) >
	^'<h3>' , (self collectString: flow) , '</h3>'! !

!PWStringActor methodsFor: 'argument' stamp: 'chc 3/24/2016 09:54'!
Italic: flow
	<action: 'Italic' arguments: #(2)>
	^'<i>' , (self collectString: flow) , '</i>'
	
	"^(Character value: 16ra3) asString , (self collectString: flow) , (Character value: 16ra3) asString"! !

!PWStringActor methodsFor: 'argument' stamp: 'chc 3/30/2016 09:16'!
Link: flow
	<action: 'LinkShort' arguments: #( 2 )>
	| linkContent |
	linkContent := self collectString: flow.
	^'<a href="' , linkContent , '">' , linkContent , '</a>'! !

!PWStringActor methodsFor: 'no-argument' stamp: 'chc 1/2/2016 13:19'!
Page: flow
	<action: 'Page'>
	^'<div>' , (self collectString: flow) , '</div>'! !

!PWStringActor methodsFor: 'no-argument' stamp: 'chc 11/25/2015 19:28'!
Paragraph: flow
	<action: 'Paragraph'>
	^'<p>' , (self collectString: flow) , '</p>'! !

!PWStringActor methodsFor: 'argument' stamp: 'chc 3/22/2016 10:17'!
UnorderedList: flow
	<action: 'UnorderedList'>
	^'<ul>' , (self collectString: flow) , '</ul>'! !

!PWStringActor methodsFor: 'private' stamp: 'chc 11/25/2015 19:27'!
collectString: flow
	| string |
	string := String new writing.
	flow do: [:ea| string write: ea].
	^string conclusion! !
